function [fitresult, gof] = carnahanStarlingFit(phi, pressure, dim)
%CREATEFIT(PHI,PRESSURE)
%  Create a fit.
%
%  Data for 'untitled fit 1' fit:
%      X Input : phi
%      Y Output: pressure
%  Output:
%      fitresult : a fit object representing the fit.
%      gof : structure with goodness-of fit info.
%
%  See also FIT, CFIT, SFIT.

%  Auto-generated by MATLAB on 11-Feb-2020 14:47:06


%% Fit: 'untitled fit 1'.
[xData, yData] = prepareCurveData( phi, pressure );

% Set up fittype and options.
ft = fittype( ['1 + 2^(',num2str(dim),' - 1) * x .* (1-a.*x)./((1-x).^',num2str(dim),')'], 'independent', 'x', 'dependent', 'y' );
opts = fitoptions( 'Method', 'NonlinearLeastSquares','maxiter',4000,'maxfunevals',10000,'robust','bisquare','tolfun',1e-9,'tolx',1e-9);
opts.Display = 'Off';
opts.StartPoint = 0.801849923688361;

% Fit model to data.
[fitresult, gof] = fit( xData, yData, ft, opts );

% % Plot fit with data.
% figure( 'Name', 'untitled fit 1' );
% h = plot( fitresult, xData, yData );
% legend( h, 'pressure vs. phi', 'untitled fit 1', 'Location', 'NorthEast', 'Interpreter', 'none' );
% % Label axes
% xlabel( 'phi', 'Interpreter', 'none' );
% ylabel( 'pressure', 'Interpreter', 'none' );
% grid on


