function [] = finSizeStructAndDynamics()

% This function recreates Fig 8. The only thing necessary for the function 
% to run is the inclusion of the matlab functions included in the 
% repository and the renaming of newSaveDir immediately below to reflect 
% its placement in your personal directory.

% This should be changed such that /Users/pkmorse/Documents/Data/Duke
% the name of the folder containing the finSizeStructureAndDynamics folder

newSaveDir = '/Users/pkmorse/Documents/Data/Duke/finSizeStructureAndDynamics/0.3/';

phidList = [NaN,NaN,NaN,1.2084,1.5131,1.9790,2.712,3.8889,5.7508,NaN,13.3574,NaN,38.6295,NaN,106.9856,NaN,334.2512];
phiOnList = [NaN,NaN,NaN,0.8106,0.9499,1.1611,1.4816,1.9711,2.7285,NaN,5.9375,NaN,14.2759,NaN,39.3243,NaN,120.5835];

minVal = NaN(17,1);
minPos = NaN(17,1);
minValOn = NaN(17,1);
minPosOn = NaN(17,1);
minValOnErr = NaN(17,1);
minPosOnErr = NaN(17,1);

figure(311)
clf; hold all
plot([1e-4 6e-4],[0.419052 0.419052],'-b','linewidth',2)
plot([1e-4 6e-4],[0.414101 0.414101],'-r','linewidth',2)
figure(611)
clf; hold all
plot([1e-4 6e-4],[0.0166567 0.0166567],'-b','linewidth',2)
plot([1e-4 6e-4],[0.0153321 0.0153321],'-r','linewidth',2)
figure(313)
clf; hold all
plot([7e-5 4e-4],[0.407991 0.407991],'-b','linewidth',2)
plot([7e-5 4e-4],[0.406524 0.406524],'-r','linewidth',2)
figure(613)
clf; hold all
plot([7e-5 4e-4],[0.00915584 0.00915584],'-b','linewidth',2)
plot([7e-5 4e-4],[0.00832805 0.00832805],'-r','linewidth',2)
figure(309)
clf; hold all
plot([1e-4 3e-3],[0.440112 0.440112],'-b','linewidth',2)
plot([1e-4 3e-3],[0.429457 0.429457],'-r','linewidth',2)
figure(609)
clf; hold all
plot([1e-4 3e-3],[0.0295043 0.0295043],'-b','linewidth',2)
plot([1e-4 3e-3],[0.0275152 0.0275152],'-r','linewidth',2)

for dim = [9 11 13]
    nPList = dir([newSaveDir,filesep,num2str(dim),filesep,'*',filesep,'*']);
    nPCandidates = zeros(1,numel(nPList));
    for i = 1:numel(nPList)
        nPCandidates(i) = str2double(nPList(i).name);
    end
    nParticleList = unique(nPCandidates(~isnan(nPCandidates)));
    if dim == 5
        nParticleList = [600];
    end
    
    for i = 1:numel(nParticleList)
        phiDirList = dir([newSaveDir,filesep,num2str(dim),filesep,'*']);
        keepers = true(numel(phiDirList),1);
        for j = 1:numel(phiDirList)
            keepers(j) = ~strcmp(phiDirList(j).name,'..')&&~strcmp(phiDirList(j).name,'.');
        end
        phiDirList = phiDirList(keepers);
        rho = NaN(1,numel(phiDirList));
        for j = 1:numel(phiDirList)
            if ~isnan(str2double(phiDirList(j).name))
                rho(j) = str2double(phiDirList(j).name);
            end
        end
        rho = rho(~isnan(rho));
        [~,order] = sort(rho);
        phiDirList = phiDirList(order);
        rho = NaN(numel(phiDirList),1);
        pressure = NaN(numel(phiDirList),1);
        perr = NaN(numel(phiDirList),1);
        phi = NaN(numel(phiDirList),1);
        
        for j = 1:numel(phiDirList)
            try
                thisFolder = [newSaveDir,filesep,num2str(dim),filesep,phiDirList(j).name,filesep,num2str(nParticleList(i)),filesep];
                [~,~] = mkdir(thisFolder);
                rho(j) = str2double(phiDirList(j).name);
                gofrFile = [thisFolder,filesep,'gofr.dat'];
                gofr = load(gofrFile);
                
                % gofr is averaged in the repository. If running with your
                % own generated data from the simulations, uncomment this
                % section and run once to average and save into one file.

%                 gofrSet = dir([newSaveDir,filesep,num2str(dim),filesep,phiDirList(j).name,filesep,num2str(nParticleList(i)),filesep,'*',filesep,'gofr.dat']);
%                 gofr = load([gofrSet(1).folder,filesep,'gofr.dat']);
%                 gofr(:,2) = 0;
%                 for ii = 1:numel(gofrSet)
%                     tempgofr = load([gofrSet(ii).folder,filesep,'gofr.dat']);
%                     gofr(:,2) = gofr(:,2) + tempgofr(:,2);
%                 end
%                 gofr(:,2) = gofr(:,2)/numel(gofrSet);
%                 saveascii(gofr,gofrFile,'%3.16d');
                
                figure(dim * 100000 + i)
                if dim == 3
                    [res,err] = fit(gofr(1:6,1)-1,gofr(1:6,2),'poly3');
                else
                    [res,err] = fit(gofr(1:11,1)-1,gofr(1:11,2),'poly3');
                end
                x = linspace(0,0.04,100);
                thisPhi = rho(j)/(2^dim /hyperBallVolume(dim));
                phi(j) = thisPhi;
                pressure(j) = (1 + 2^(dim-1)*thisPhi * res.p4);
                coeff = confint(res);
                perr(j) = 2^(dim-1)*thisPhi * (coeff(2,4) - res.p4);
                
                if abs(rho(j)-phidList(dim)) < 1e-5
                    [~,~,~,d,e] = gofrstats(gofr(:,1),gofr(:,2),3232,0.9995);
                    minVal(dim) = 1 - e;
                    minPos(dim) = d - 1;
                end
                
                if abs(rho(j) - phiOnList(dim)) < 1e-3
                    if dim == 11
                        range = gofr(:,2) < 1 & gofr(:,1) > 1 & gofr(:,1) < 1.6;
                    elseif dim == 13
                        range = gofr(:,2) < 1 & gofr(:,1) > 1 & gofr(:,1) < 1.6;
                    else
                        range = gofr(:,2) < 1 & gofr(:,1) > 1 & gofr(:,1) < 1.65;
                    end
                    [res2,err] = fit(gofr(range,1),gofr(range,2),'-a*(x-b)^2*(x-d) + c','startPoint',[0.1 1.4 1 3],'lower',[0 1.35 0.9 1.5],'upper',[Inf 1.5 1 Inf]);

                    minPosOn(dim) = res2.b-1;
                    minValOn(dim) = 1-res2.c;
                    con = confint(res2);
                    minPosOnErr(dim) = con(2,2) - res2.b;
                    minValOnErr(dim) = con(2,3) - res2.c;
                    figure(600+dim)
                    errorbar(1./nParticleList(i),minValOn(dim),minValOnErr(dim),'p','markersize',10,'color',[0.5 0 0.5]);
                    figure(300+dim)
                    h2 = errorbar(1./nParticleList(i),minPosOn(dim),minPosOnErr(dim),'p','markersize',10,'color',[0.5 0 0.5]);
                end
                
            catch
            end            
        end        
    end
end

d = (1:17)';

figure(611)
title('$d=11, \widehat{\varphi}=1$','interpreter','latex')
xlabel('$1/N$','interpreter','latex')
ylabel('$1-g(r_0)$','interpreter','latex')
xlim([1e-4 6e-4])
plotSpecs()

figure(311)
title('$d=11, \widehat{\varphi}=1$','interpreter','latex')
xlabel('$1/N$','interpreter','latex')
ylabel('$r_0-1$','interpreter','latex')
xlim([1e-4 6e-4])
legend('PY','HNC','HS','interpreter','latex','location','southwest')
plotSpecs()

figure(613)
title('$d=13, \widehat{\varphi}=1$','interpreter','latex')
xlabel('$1/N$','interpreter','latex')
ylabel('$1-g(r_0)$','interpreter','latex')
xlim([7e-5 4e-4])
plotSpecs()

figure(313)
title('$d=13, \widehat{\varphi}=1$','interpreter','latex')
xlabel('$1/N$','interpreter','latex')
ylabel('$r_0-1$','interpreter','latex')
xlim([7e-5 4e-4])
plotSpecs()

figure(609)
title('$d=9, \widehat{\varphi}=1$','interpreter','latex')
xlabel('$1/N$','interpreter','latex')
ylabel('$1-g(r_0)$','interpreter','latex')
axis([1e-4 3e-3 0.02 0.05])
set(gca,'xscale','log')
plotSpecs()

figure(309)
title('$d=9, \widehat{\varphi}=1$','interpreter','latex')
xlabel('$1/N$','interpreter','latex')
ylabel('$r_0-1$','interpreter','latex')
xlim([1e-4 3e-3])
ylim([0.4 0.47])
set(gca,'xscale','log')
legend('PY','HNC','HS','interpreter','latex','location','southwest')
plotSpecs()

end