function [] = highDStructAndDynamics()

% This function generates Table 2, Figs. 1, 2a-c, 3, 4, 5, 6, and 7. The
% only thing necessary for the function to run is the inclusion of the
% matlab functions included in the repository and the renaming of
% newSaveDir immediately below to reflect its placement in your personal
% directory.

% This should be changed such that /Users/pkmorse/Documents/Data/Duke
% the name of the folder containing the liquidStructureAndDynamics folder
newSaveDir = '/Users/pkmorse/Documents/Data/Duke/liquidStructureAndDynamics/0.3/';

for i = 1:9
    figure(i*1111)
    clf; hold all
end

figure(197)
clf; hold all

figure(1)
clf; hold all

figure(2)
clf; hold all

phidList = [NaN,NaN,NaN,1.2084,1.5131,1.9790,2.712,3.7976,5.6516,8.5089,13.1016,21.3611,33.5558,NaN,106.9856,NaN,334.2512];
phiOnList = [NaN,NaN,NaN,0.8106,0.9499,1.1611,1.4816,1.9711,2.7802,3.9213,5.9375,8.9870,14.2759,NaN,39.3243,NaN,120.5835];
phiSER = [NaN NaN 0.555 0.389 0.260 0.168 0.106 1 1 1 1 1 1 1 1 1 1 1];
phiDEstimate = [NaN NaN 0.577  0.402875000000000 0.268656250000000 0.172753125000000 0.108614843750000 0.066331250000000 0.039960351562500 0.022757812500000 0.012816064453125 0.007509960937500 0.004734765625000];
loPhiHat = (phiDEstimate .* 2.^(1:13)./(1:13) - 1)/2 + 1;

iRange = 1;

minVal = NaN(17,1);
minPos = NaN(17,1);
minValOn = NaN(17,1);
minPosOn = NaN(17,1);
slopeOn = NaN(17,1);
slopeD = NaN(17,1);
alphaCS = NaN(17,1);
alphaCSErr = NaN(17,1);
alphaCSNonFit = NaN(17,1);
phid = NaN(17,1);
phiDErr = NaN(17,1);
pressureD = NaN(17,1);
pressureDErr = NaN(17,1);
pressureDInvErr = NaN(17,1);
gam = NaN(17,1);
gamErr = NaN(17,1);

for dim = 4:13
    if dim > 9
        numM = 1; %Use even the last few data points with one run
    else
        numM = 2; %Limit to data points with at least 2 averages
    end
    dimIndex = [0 0 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14];
    numDim = 10;
    figure(200+dim)
    clf; hold all
    
    for i = iRange
        figure(dim*10 + i)
        clf; hold all
    end
    
    figure(dim*10)
    clf; hold all
    figure(dim)
    clf; hold all
    figure(dim * 100)
    clf; hold all
    figure(dim * 1000)
    clf; hold all
    figure(dim * 100000)
    clf; hold all
    figure(dim*10+2)
    clf; hold all
    nPList = dir([newSaveDir,filesep,num2str(dim),filesep,'*',filesep,'*']);
    nPCandidates = zeros(1,numel(nPList));
    for i = 1:numel(nPList)
        nPCandidates(i) = str2double(nPList(i).name);
    end
    nParticleList = [0 0 0 1024 1024 1000 1000 1800 2000 4500 5000 8000 4000 0 5000 0 7000];

    nParticleList = nParticleList(dim);
    for i = 1:numel(nParticleList)
        figure(dim * 1100 + i)
        clf; hold all
        figure(dim * 10 + i)
        clf; hold all
        phiDirList = dir([newSaveDir,filesep,num2str(dim),filesep,'*']);
        keepers = true(numel(phiDirList),1);
        for j = 1:numel(phiDirList)
            keepers(j) = ~strcmp(phiDirList(j).name,'..')&&~strcmp(phiDirList(j).name,'.');
        end
        phiDirList = phiDirList(keepers);
        rho = NaN(1,numel(phiDirList));
        for j = 1:numel(phiDirList)
            if ~isnan(str2double(phiDirList(j).name))
                rho(j) = str2double(phiDirList(j).name);
            end
        end
        rho = rho(~isnan(rho));
        [~,order] = sort(rho);
        phiDirList = phiDirList(order);
        rho = NaN(numel(phiDirList),1);
        xExp = NaN(numel(phiDirList),1);
        rsq = NaN(numel(phiDirList),1);
        pressure = NaN(numel(phiDirList),1);
        perr = NaN(numel(phiDirList),1);
        phi = NaN(numel(phiDirList),1);
        longDiff = NaN(numel(phiDirList),1);
        longDiffStd = NaN(numel(phiDirList),1);
        
        phiList = {};
        thisSet = 1;
        for j = 1:numel(phiDirList)
            try
                thisFolder = [newSaveDir,filesep,num2str(dim),filesep,phiDirList(j).name,filesep,num2str(nParticleList(i)),filesep];
                [~,~] = mkdir(thisFolder);
                rho(j) = str2double(phiDirList(j).name);
                gofrFile = [thisFolder,filesep,'gofr.dat'];
                % Average gofr files, then save them. Removed in archived
                % version.
                
%                 gofrSet = dir([basedir,filesep,num2str(dim),filesep,phiDirList(j).name,filesep,num2str(nParticleList(i)),filesep,'*',filesep,'gofr.dat']);
%                 gofr = load([gofrSet(1).folder,filesep,'gofr.dat']);
%                 gofr(:,2) = 0;
%                 for ii = 1:numel(gofrSet)
%                     tempgofr = load([gofrSet(ii).folder,filesep,'gofr.dat']);
%                     gofr(:,2) = gofr(:,2) + tempgofr(:,2);
%                 end
%                 gofr(:,2) = gofr(:,2)/numel(gofrSet);
%                 saveascii(gofr,gofrFile,'%3.16d');
                                
                gofr = load(gofrFile);
                
                figure(dim * 100000 + i)
                
                plot(gofr(:,1),gofr(:,2),'-','Color',[(j-1)/(numel(phiDirList) - 1) 0 1 - (j-1)/(numel(phiDirList) - 1)])
                phiList{thisSet} = num2str(str2double(phiDirList(j).name)*hyperBallVolume(dim)/2^dim,'%3.4f');
                thisSet = thisSet+1;
                
                if dim == 3
                    [res,err] = fit(gofr(1:6,1)-1,gofr(1:6,2),'poly3');
                else
                    [res,err] = fit(gofr(1:11,1)-1,gofr(1:11,2),'poly3');
                end
                x = linspace(0,0.04,100);
                thisPhi = rho(j)/(2^dim /hyperBallVolume(dim));
                phi(j) = thisPhi;
                pressure(j) = (1 + 2^(dim-1)*thisPhi * res.p4);
                coeff = confint(res);
                perr(j) = 2^(dim-1)*thisPhi * (coeff(2,4) - res.p4);
                
                if abs(rho(j)-phidList(dim)) < 1e-5
                    [~,~,~,d,e] = gofrstats(gofr(:,1),gofr(:,2),3232,0.9999);
                    minVal(dim) = 1 - e;
                    minPos(dim) = d - 1;
                    slopeD(dim) = res.p3;
                    figure(dim*1000000)
                    plot(gofr(:,1),gofr(:,2),'Color',[0.5 0 0.5],'Linewidth',1.5)
                end
                
                if abs(rho(j) - phiOnList(dim)) < 1e-3
                    [~,~,~,d,e] = gofrstats(gofr(:,1),gofr(:,2),3232,0.9999);
                    minValOn(dim) = 1 - e;
                    minPosOn(dim) = d - 1;
                    slopeOn(dim) = res.p3;
                    figure(dim*1000000)
                    plot(gofr(:,1),gofr(:,2)-1,'Color',[0.5 0 0.5],'Linewidth',1.5)
                end                
            catch
            end
            
            try
                muFile = [thisFolder,filesep,'msdShort.dat'];
                ltuFile = [thisFolder,filesep,'tShort.dat'];
                figure(dim*10+i)
                col = [(j-1)/(numel(phiDirList) - 1) 0 1 - (j-1)/(numel(phiDirList) - 1)];
                if exist(muFile,'file') && exist(ltuFile,'file')
                    msd = load(muFile);
                    ttt = load(ltuFile);
                else
                    % Using the data format generated by the simulations,
                    % this saves a subset of data and uses it to generate
                    % the scaling of D with phi. In retrospect, this is
                    % entirely too much data, and it only needed to be
                    % saved in logscale, which is what is done in the data
                    % deposition. The method used to analyze data
                    % from the paper is included in a subcomment below. The
                    % method available here produces values which lie
                    % whose error bars overlap with those in the paper.
                    
%                     thismsd = load([basedir,filesep,num2str(dim),filesep,phiDirList(j).name,filesep,num2str(nParticleList(i)),filesep,'msd.dat']);
%                     msdDivide = load([basedir,filesep,num2str(dim),filesep,phiDirList(j).name,filesep,num2str(nParticleList(i)),filesep,'msdDivide.dat']);
%                     if dim == 5
%                         % 5d data was run 3x longer, cut down for equal
%                         % comparison
%                         thismsd = thismsd(1:floor(0.3*numel(thismsd)));
%                         msdDivide = msdDivide(1:floor(0.3*numel(msdDivide)));
%                     end
% 
%                     msd = thismsd(msdDivide>numM)./msdDivide(msdDivide>numM);
%                     t = 1:numel(msd);
%                     lt = log10(t');
%                     msd = msd/msd(1);
%                     t = (1:numel(msd))';
%                     m = msd./t;
% 
%                     % ltu and mu are the versions used in the actual data
%                     % analysis, but they are much too large for data
%                     % deposition, so a subset is saved. This subset
%                     % produces values which are within those reported in
%                     % the manuscript.
%                     
% %                     ltu = lt(floor(exp(log(numel(lt))*0.7)):10:end);
% %                     mu = m(floor(exp(log(numel(lt))*0.7)):10:end);
%                     
%                     t = (1:numel(msd))';
%                     ttt = unique(floor(sqrt(1.2).^(1:floor(log(t(end))/log(sqrt(1.2))))'));
% 
%                     saveascii(msd(ttt),muFile,'%3.16d');
%                     saveascii(ttt,ltuFile,'%3.16d');
%                     
%                     msd = msd(ttt);
                end
                DEff = msd./ttt;
                plot(ttt,DEff,'-','Color',col,'linewidth',2);
                LogTUpper = log(ttt(floor(0.7*numel(ttt)):end));
                DEffUpper = DEff(floor(0.7*numel(ttt)):end);
                [res,~] = fit(LogTUpper,DEffUpper,'a + b*exp((-x/c))','startpoint',[min(DEffUpper) 0.05 2],'lower',[0.9*min(DEffUpper) 1e-2 0.1],'upper',[max(DEffUpper) 1000 LogTUpper(end)],'maxiter',10000,'maxfunevals',10000,'robust','bisquare','tolfun',3e-4,'tolx',3e-4);
                longDiff(j) = res.a;
            catch
            end
        end
        figure(dim * 100000 + i)
        legend(phiList,'numcolumns',2,'location','northeast')
        if numel(nParticleList) > 1
            nColor = [(i-1)/(numel(nParticleList) - 1) 0 1 - (i-1)/(numel(nParticleList) - 1)];
        else
            nColor = [1 0 0];
        end
        try
            figure(dim*100 + i)
            plot(phi(~isnan(xExp)&~isnan(phi)),xExp(~isnan(xExp)&~isnan(phi)),'.-','Color',nColor)
        catch
        end
        
        try
            figure(dim*1000+i)
            plot(phi(~isnan(rsq)&~isnan(phi)),rsq(~isnan(rsq)&~isnan(phi)),'.-','Color',nColor)
        catch
        end
        
        pressure = pressure(~isnan(rho));
        perr = perr(~isnan(rho));
        phi = phi(~isnan(rho));
        longDiff = longDiff(~isnan(rho));
        longDiffStd = longDiffStd(~isnan(rho));
        figure(dim*10+3)
        
        
        try
            % Assymptotic gamma 2.33786
            [res,err] = fit(phi(phi>loPhiHat(dim)*dim*2^(-dim) & ~isnan(longDiff) & phi < phiSER(dim)),log(1./longDiff(phi>loPhiHat(dim)*dim*2^(-dim) & ~isnan(longDiff) & phi < phiSER(dim))),'-c*log(a*(1-x/b))','startpoint',[1,1.05*max(phi),2],'lower',[0.1,max(phi),1.1],'upper',[inf,0.6,2.8],'maxfunevals',8000,'maxIter',8000,'diffminchange',1e-9,'robust','bisquare');
            coeff = confint(res);
            phid(dim) = res.b;
            phiDErr(dim) = coeff(2,2) - res.b;
            gam(dim) = res.c;
            gamErr(dim) = coeff(2,3) - res.c;
        catch
        end
        
        disp(nParticleList(i))
        disp(res)
        disp(err)

    
        figure(dim*10 + i)
        set(gca,'xscale','log')
        set(gca,'yscale','log')
        ylabel('$\langle r^2(t)\rangle$','interpreter','latex')
        xlabel('$t$','interpreter','latex')
        disp("gam is")
        disp(gam)
        disp("gamErr is")
        disp(gamErr)
        disp("phid is")
        disp(phid .* 2.^(1:17)'./(1:17)')
        disp("phidErr is")
        disp(phiDErr .* 2.^(1:17)'./(1:17)')
        color = [(dimIndex(dim)-1)/numDim 0 1-(dimIndex(dim)-1)/numDim];
        figure(1)
        errorbar(2^(dim)*(phid(dim)-phi)/dim,2*dim^2*longDiff*dim^2,2*dim^2*longDiffStd*dim^2,'.','Color',color)
        plot(2^(dim)*(phid(dim)-phi)/dim,dim^2./(exp(feval(res,phi))/(2*dim^2)),'-','Color',color)
        
        figure(2)
        errorbar(1-phi/phid(dim),2*dim^2*longDiff*dim^2,2*dim^2*longDiffStd*dim^2,'.','Color',color)
        plot(1-phi/phid(dim),(2*dim^2)*dim^2./exp(feval(res,phi)),'-','Color',color)
        figure(197)
        errorbar((2.^dim).*(phi./dim),dim./pressure,dim.*perr./(pressure.^2),'.','Color',color)
        phi2 = linspace(0,phid(dim),100)';
        [res5,err] = carnahanStarlingFit(phi,pressure,dim);
        coeff = confint(res5);
        aErr = coeff(2) - res5.a;
        alphaCS(dim) = res5.a;
        alphaCSErr(dim) = aErr;        
        alphaCSNonFit(dim) = dim-(2.^(dim-1).*2.*(1-hypergeom([0.5, (1-dim)/2],3/2,1/4)./beta(1/2,(dim+1)/2)));
        
        figure(dim + 1000)
        clf; hold all
        rho2 = phi2./(hyperBallVolume(dim)/2^dim);
        Z = padeApproxHSFluid(rho2,dim,0);
        errorbar(phi*2^dim/dim,pressure/dim,perr/dim,'.k')
        plot(phi2*2^dim/dim,feval(res5,phi2)/dim,'-','Color',[0 0.8 0.8],'Linewidth',1.5)
        plot(phi2*2^dim/dim,Z/dim,'-','Linewidth',1.5,'Color',[0.5 0 0.5])        
        
        figure(197)
        [res,err] = carnahanStarlingFit(phi,pressure,dim);
        coeff = confint(res);
        aErr = coeff(2) - res.a;
        pr = 1 + 2^(dim - 1) * phi2 .* (1-res.a.*phi2)./((1-phi2).^dim);
        prErr = 2^(dim-1)/(1-phid(dim))^dim * sqrt(aErr^2 * phid(dim)^4 + phiDErr(dim)^2/(1-phid(dim))^2*(phid(dim)-1-dim*phid(dim)+res.a*phid(dim)*(2+(dim-2)*phid(dim)))^2);
        dpErr = dim/pr(end)^2*prErr;
        pressureD(dim) = pr(end);
        pressureDErr(dim) = prErr(end);
        pressureDInvErr(dim) = dpErr(end);
        phiCoErr = 2^dim*phiDErr(dim)/dim;
        h1 = plot((2.^dim).*(phi2./dim),dim./pr,'-','Color',color);
        set(get(get(h1,'Annotation'),'LegendInformation'),'IconDisplayStyle','off');
        h2 = errorbar((2.^dim).*(phi2(end)./dim),dim./pr(end),dpErr,dpErr,phiCoErr,phiCoErr,'s','Color',color,'MarkerSize',5,'MarkerFaceColor',color);
        set(get(get(h2,'Annotation'),'LegendInformation'),'IconDisplayStyle','off');
    end
    disp(["this was dim",num2str(dim)])
end

figure(234)
clf; hold all
errorbar(1./(1:17)',gam,gamErr,'.k','markersize',15)

d = (1:17)';

figure(1)
xlabel('$\widehat{\varphi}_\mathrm{d} - \widehat{\varphi}$','interpreter','latex')
ylabel('$\tau_\alpha$','interpreter','latex')
plotSpecs()

figure(6666)
h2=plot(1./d,minValOn,'p','markersize',10,'color',[0.5 0 0.5]);
plot(1./d,minVal,'p','markersize',10,'color',[0.5 0 0.5],'markerFaceColor',[0.5 0 0.5])
set(get(get(h2,'Annotation'),'LegendInformation'),'IconDisplayStyle','off');
set(gca,'yscale','log')
xlabel('$1/d$','interpreter','latex')
ylabel('$1-g(r_{0})$','interpreter','latex')
plotSpecs()
xlim([0 0.3])

figure(3333)
h2=plot(1./d,minPosOn,'p','markersize',10,'color',[0.5 0 0.5]);
plot(1./d,minPos,'p','markersize',10,'color',[0.5 0 0.5],'markerFaceColor',[0.5 0 0.5])
set(get(get(h2,'Annotation'),'LegendInformation'),'IconDisplayStyle','off');
xlabel('$1/d$','interpreter','latex')
ylabel('$r_{0}-1$','interpreter','latex')
plotSpecs()
xlim([0 0.3])
ylim([0.2 0.6])

figure(9999)
plot(1./d,-slopeD,'p','color',[0.5 0 0.5],'markersize',10);
h2=plot(1./d,-slopeOn,'p','color',[0.5 0 0.5],'markersize',10);
set(get(get(h2,'Annotation'),'LegendInformation'),'IconDisplayStyle','off');
set(gca,'yscale','log')
xlim([0 0.3])
plotSpecs()

figure(222)
clf; hold all
errorbar(1./d(~isnan(alphaCS)),-alphaCS(~isnan(alphaCS)).*d(~isnan(alphaCS))./2.^d(~isnan(alphaCS)),alphaCSErr(~isnan(alphaCS)).*d(~isnan(alphaCS))./2.^d(~isnan(alphaCS)),'o-','color','k','markersize',5,'markerfacecolor','k');
plot(1./d(~isnan(alphaCSNonFit)),-alphaCSNonFit(~isnan(alphaCSNonFit)).*d(~isnan(alphaCSNonFit))./2.^d(~isnan(alphaCSNonFit)),'o-','color','r','markersize',5,'markerfacecolor','r')
ylabel('$\widehat{A}$','interpreter','latex')
xlabel('$1/d$','interpreter','latex')
xlim([0 0.3])
ylim([-0.2 0.8])
plotSpecs()


figure(137)
errorbar(1./d(~isnan(phid)),phid(~isnan(phid))./d(~isnan(phid)).*2.^d(~isnan(phid)),phiDErr(~isnan(phid))./d(~isnan(phid)).*2.^d(~isnan(phid)),'p-','color',[0.5 0 0.5],'markersize',10,'markerfacecolor',[0.5 0 0.5]);

figure(147)
errorbar(1./d(~isnan(pressureD)),(pressureD(~isnan(pressureD))./d(~isnan(pressureD))).^-1,pressureDInvErr(~isnan(pressureD))./d(~isnan(pressureD)),'p-','color',[0.5 0 0.5],'markersize',10,'markerfacecolor',[0.5 0 0.5]);

disp(pressureD)
disp(pressureDInvErr)
disp(pressureDErr)

figure(2222)
clf; hold all
plot(1./(1:17),(1-alphaCS.*phid)./((1-phid).^((1:17)')),'o','color','k','markersize',5,'markerfacecolor','k');

disp(phid)
disp(phiDErr)
disp(minVal)
disp(minPos)
disp(-alphaCS(~isnan(alphaCS)).*d(~isnan(alphaCS))./2.^d(~isnan(alphaCS)))
disp(alphaCSErr(~isnan(alphaCS)).*d(~isnan(alphaCS))./2.^d(~isnan(alphaCS)))

end