#ifndef ENUMTYPES_H_
#define ENUMTYPES_H_


struct simControlStruct {
	enum class neighborEnum {allToAll, nList, hex2D} neighborType;
	enum class distanceEnum {MK, nonAdditive, normal} distanceType;
	enum class geometryEnum {normal, nonSquare, leesEdwards, E8, Dn} geometryType;
	enum class potentialEnum {contactPower, log, wca, inversePower} potentialType;
	enum class constraintEnum {normal, strainControl, stressControl} constraintType;
	enum class einsteinEnum {none, spring, springUntethered, periodic, periodicUmbrella, periodicUmbrellaExp} einsteinType;
	enum class particleEnum {cube, sphere} particleType;
	enum class monteCarloEnum {ecmc, metropolis} monteCarloType;
	enum class ensembleEnum {nvt, npt} ensembleType;
};

#endif /* ENUMTYPES_H_ */